Index: trunk/kernel/drivers/soclib/soclib_iob.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_iob.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_iob.c	(revision 1)
@@ -0,0 +1,138 @@
+/*
+ * soclib_iob.c - soclib IOB driver API implementation.
+ *
+ * Alain Greiner    (2017)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <hal_remote.h>
+#include <soclib_iob.h>
+
+/////////////////////////////////////
+void soclib_iob_init( xptr_t iox_xp )
+{
+    // get IOX device cluster and local pointer
+    cxy_t      iox_cxy = GET_CXY( iox_xp );
+    device_t * iox_ptr = (device_t *)GET_PTR( iox_xp );
+
+    // get extended pointer on SOCLIB_IOB base_xp segment
+    xptr_t base_xp = (xptr_t)hal_remote_lwd( XPTR( iox_cxy , &iox_ptr->base ) );
+
+    // desactivate IOMMU
+    hal_remote_sw( base_xp + (IOB_IOMMU_ACTIVE<<2) , 0 );
+}
+
+////////////////////////////////////////////
+void soclib_iob_set_active( xptr_t   iox_xp,
+                            uint32_t value )
+{
+    // get IOX device cluster and local pointer
+    cxy_t      iox_cxy = GET_CXY( iox_xp );
+    device_t * iox_ptr = (device_t *)GET_PTR( iox_xp );
+
+    // get extended pointer on SOCLIB_IOB base_xp segment
+    xptr_t base_xp = (xptr_t)hal_remote_lwd( XPTR( iox_cxy , &iox_ptr->base ) );
+
+    // set ACTIVE register
+    hal_remote_sw( base_xp + (IOB_IOMMU_ACTIVE<<2) , value );
+}
+
+//////////////////////////////////////////
+void soclib_iob_set_ptpr( xptr_t   iox_xp,
+                          uint32_t value )
+{
+    // get IOX device cluster and local pointer
+    cxy_t      iox_cxy = GET_CXY( iox_xp );
+    device_t * iox_ptr = (device_t *)GET_PTR( iox_xp );
+
+    // get extended pointer on SOCLIB_IOB base_xp segment
+    xptr_t base_xp = (xptr_t)hal_remote_lwd( XPTR( iox_cxy , &iox_ptr->base ) );
+
+    // set PTPR register
+    hal_remote_sw( base_xp + (IOB_IOMMU_PTPR<<2) , value );
+}
+
+///////////////////////////////////////////
+void soclib_iob_inval_page( xptr_t  iox_xp,
+                            vpn_t   vpn )
+{
+    // get IOX device cluster and local pointer
+    cxy_t      iox_cxy = GET_CXY( iox_xp );
+    device_t * iox_ptr = (device_t *)GET_PTR( iox_xp );
+
+    // get extended pointer on SOCLIB_IOB base_xp segment
+    xptr_t base_xp = (xptr_t)hal_remote_lwd( XPTR( iox_cxy , &iox_ptr->base ) );
+
+    // invalidate TLB entry
+    hal_remote_sw( base_xp + (IOB_INVAL_PTE<<2) , vpn );
+}
+
+//////////////////////////////////////////////
+uint32_t soclib_iob_get_bvar( xptr_t  iox_xp )
+{
+    // get IOX device cluster and local pointer
+    cxy_t      iox_cxy = GET_CXY( iox_xp );
+    device_t * iox_ptr = (device_t *)GET_PTR( iox_xp );
+
+    // get extended pointer on SOCLIB_IOB base_xp segment
+    xptr_t base_xp = (xptr_t)hal_remote_lwd( XPTR( iox_cxy , &iox_ptr->base ) );
+
+    // get BVAR register
+    return hal_remote_lw( base_xp + (IOB_IOMMU_BVAR<<2) );
+}
+
+///////////////////////////////////////////////
+uint32_t soclib_iob_get_srcid( xptr_t  iox_xp )
+{
+    // get IOX device cluster and local pointer
+    cxy_t      iox_cxy = GET_CXY( iox_xp );
+    device_t * iox_ptr = (device_t *)GET_PTR( iox_xp );
+
+    // get extended pointer on SOCLIB_IOB base_xp segment
+    xptr_t base_xp = (xptr_t)hal_remote_lwd( XPTR( iox_cxy , &iox_ptr->base ) );
+
+    // get BVAR register
+    return hal_remote_lw( base_xp + (IOB_IOMMU_SRCID<<2) );
+}
+
+///////////////////////////////////////////////
+uint32_t soclib_iob_get_error( xptr_t  iox_xp )
+{
+    // get IOX device cluster and local pointer
+    cxy_t      iox_cxy = GET_CXY( iox_xp );
+    device_t * iox_ptr = (device_t *)GET_PTR( iox_xp );
+
+    // get extended pointer on SOCLIB_IOB base_xp segment
+    xptr_t base_xp = (xptr_t)hal_remote_lwd( XPTR( iox_cxy , &iox_ptr->base ) );
+
+    // get BVAR register
+    return hal_remote_lw( base_xp + (IOB_IOMMU_ERROR<<2) );
+}
+
+
+// Local Variables:
+// tab-width: 4
+// c-basic-offset: 4
+// c-file-offsets:((innamespace . 0)(inline-open . 0))
+// indent-tabs-mode: nil
+// End:
+// vim: filetype=c:expandtab:shiftwidth=4:tabstop=4:softtabstop=4
+
Index: trunk/kernel/drivers/soclib/soclib_iob.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_iob.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_iob.h	(revision 1)
@@ -0,0 +1,129 @@
+/*
+ * soclib_iob.h - soclib IOB driver API definition.
+ *
+ * Alain Greiner    (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_IOB_H_
+#define _SOCLIB_IOB_H_
+
+#include <hal_types.h>
+#include <device.h>
+
+/******************************************************************************************
+ *    SOCLIB_IOB  Registers Mnemonics
+ *****************************************************************************************/
+
+enum IOB_registers 
+{
+    IOB_IOMMU_PTPR       = 0,      // R/W : Page Table Pointer Register
+    IOB_IOMMU_ACTIVE     = 1,      // R/W : IOMMU activated if not 0
+    IOB_IOMMU_BVAR       = 2,      // R   : Bad Virtual Address (unmapped) 
+    IOB_IOMMU_ERROR      = 3,      // R   : Error Type 
+    IOB_IOMMU_SRCID      = 4,      // R   : Faulty Peripheral Index (SRCID)
+    IOB_INVAL_PTE        = 5,      // W   : Invalidate a PTE (virtual address)
+    IOB_WTI_ENABLE       = 6,      // R/W : Enable WTIs (both IOMMU and peripherals)
+    IOB_WTI_ADDR_LO      = 7,      // W/R : 32 LSB bits for IOMMU WTI
+    IOB_WTI_ADDR_HI      = 8,      // W/R : 32 MSB bits for IOMMU WTI
+};
+
+enum mmu_error_type_e 
+{
+    MMU_NONE                      = 0x0000, // None
+    MMU_WRITE_ACCES_VIOLATION     = 0x0008, // Write access to a non writable page 
+    MMU_WRITE_PT1_ILLEGAL_ACCESS  = 0x0040, // Write Bus Error accessing Table 1       
+    MMU_READ_PT1_UNMAPPED 	      = 0x1001, // Read  Page fault on Page Table 1  	
+    MMU_READ_PT2_UNMAPPED 	      = 0x1002, // Read  Page fault on Page Table 2  
+    MMU_READ_PT1_ILLEGAL_ACCESS   = 0x1040, // Read  Bus Error in Table1 access      
+    MMU_READ_PT2_ILLEGAL_ACCESS   = 0x1080, // Read  Bus Error in Table2 access 	
+    MMU_READ_DATA_ILLEGAL_ACCESS  = 0x1100, // Read  Bus Error in cache access 
+};
+
+
+/******************************************************************************************
+ * This function initializes the SOCLIB IOB component:
+ ******************************************************************************************
+ * @ iob_xp     : extended pointer on the remote IOX device descriptor.
+ *****************************************************************************************/
+void soclib_iob_init( xptr_t iox_xp );
+
+/******************************************************************************************
+ * This function set a new value in the IOB_IOMMU_ACTIVE register.
+ ******************************************************************************************
+ * @ iob_xp     : extended pointer on the remote XCU device descriptor.
+ * @ value      : value to be written in register.
+ *****************************************************************************************/
+void soclib_iob_set_active( xptr_t   iox_xp,
+                            uint32_t value );
+
+/******************************************************************************************
+ * This function set a new value in the IOB_IOMMU_PTPR register.
+ ******************************************************************************************
+ * @ iob_xp     : extended pointer on the remote XCU device descriptor.
+ * @ value      : value to be written in register IOMMU.
+ *****************************************************************************************/
+void soclib_iob_set_ptpr( xptr_t   iob_xp,
+                          uint32_t value );
+
+/******************************************************************************************
+ * This function invaldates a TLB entry identified by its vpn.
+ ******************************************************************************************
+ * @ iox_xp     : extended pointer on the remote XCU device descriptor.
+ * @ vpn        : virtual page number.
+ *****************************************************************************************/
+void soclib_iob_inval_page( xptr_t  iox_xp,
+                            vpn_t   vpn );
+
+/******************************************************************************************
+ * This function returns the content of IOB_IOMMU_BVAR register.
+ ******************************************************************************************
+ * @ iox_xp     : extended pointer on the remote XCU device descriptor.
+ * @ return registered bad virtual address (after error reported by IOMMU).
+ *****************************************************************************************/
+uint32_t soclib_iob_get_bvar( xptr_t  iox_xp );
+
+/******************************************************************************************
+ * This function returns the content of IOB_IOMMU_SRCID register.
+ ******************************************************************************************
+ * @ iox_xp     : extended pointer on the remote XCU device descriptor.
+ * @ return registered faulty peripheral index (after error reported by IOMMU).
+ *****************************************************************************************/
+uint32_t soclib_iob_get_srcid( xptr_t  iox_xp );
+
+/******************************************************************************************
+ * This function returns the content of IOB_IOMMU_ERROR register.
+ ******************************************************************************************
+ * @ iox_xp     : extended pointer on the remote XCU device descriptor.
+ * @ return registered error type (after error reported by IOMMU).
+ *****************************************************************************************/
+uint32_t soclib_iob_get_error( xptr_t  iox_xp );
+
+
+
+#endif
+
+// Local Variables:
+// tab-width: 4
+// c-basic-offset: 4
+// c-file-offsets:((innamespace . 0)(inline-open . 0))
+// indent-tabs-mode: nil
+// End:
+// vim: filetype=c:expandtab:shiftwidth=4:tabstop=4:softtabstop=4
+
Index: trunk/kernel/drivers/soclib/soclib_memc.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_memc.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_memc.c	(revision 1)
@@ -0,0 +1,348 @@
+/*
+ * soclib_memc.c - soclib/tsar L2 Confugration Controller
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012,2013 Ghassan Almaless
+ * Copyright (c) 2011,2012,2013 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <bits.h>
+#include <device.h>
+#include <driver.h>
+#include <drvdb.h>
+#include <errno.h>
+#include <vfs.h>
+#include <string.h>
+#include <soclib_memc.h>
+#include <vmm.h>
+
+#define MEMC_CNF_FUNC         0x0
+#define MEMC_PRF_FUNC         0x1
+#define MEMC_ERR_FUNC         0x2
+
+#define MEMC_RD_MUPDT_SEL     0x0
+#define MEMC_WR_MINVL_SEL     0x1
+#define MEMC_LL_CLNUP_SEL     0x2
+#define MEMC_SC_MUPDTT_SEL    0x3
+#define MEMC_CS_MINVLT_SEL    0x4
+#define MEMC_XX_BINVLT_SEL    0x5
+
+#define MEMC_LOC_SEL          0x0
+#define MEMC_REM_SEL          0x1
+#define MEMC_OTH_SEL          0x2
+
+#define MEMC_DIRCT_SEL        0x0
+#define MEMC_COHER_SEL        0x1
+
+#define MEMC_LO_SEL           0x0
+#define MEMC_HI_SEL           0x1
+
+#define MEMC_REG_IDX(z,y,x,w)  (((z) << 6) | ((y) << 4) | ((x) << 1) | (w))
+#define MEMC_REG(func,idx)     (((func) << 9) | ((idx) << 2))
+
+/* ---------------------------------------- */
+/* PERFORMANCE REGISTERS FOR DIRECT TRAFFIC */
+/* ---------------------------------------- */
+
+#define MEMC_RD_LIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_LOC_SEL, MEMC_RD_MUPDT_SEL, MEMC_LO_SEL))
+#define MEMC_RD_RIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_REM_SEL, MEMC_RD_MUPDT_SEL, MEMC_LO_SEL))
+#define MEMC_RD_CIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_OTH_SEL, MEMC_RD_MUPDT_SEL, MEMC_LO_SEL))
+
+#define MEMC_WR_LIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_LOC_SEL, MEMC_WR_MINVL_SEL, MEMC_LO_SEL))
+#define MEMC_WR_RIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_REM_SEL, MEMC_WR_MINVL_SEL, MEMC_LO_SEL))
+#define MEMC_WR_CIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_OTH_SEL, MEMC_WR_MINVL_SEL, MEMC_LO_SEL))
+
+#define MEMC_LL_LIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_LOC_SEL, MEMC_LL_CLNUP_SEL, MEMC_LO_SEL))
+#define MEMC_LL_RIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_REM_SEL, MEMC_LL_CLNUP_SEL, MEMC_LO_SEL))
+#define MEMC_LL_CIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_OTH_SEL, MEMC_LL_CLNUP_SEL, MEMC_LO_SEL))
+
+#define MEMC_SC_LIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_LOC_SEL, MEMC_SC_MUPDTT_SEL, MEMC_LO_SEL))
+#define MEMC_SC_RIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_REM_SEL, MEMC_SC_MUPDTT_SEL, MEMC_LO_SEL))
+#define MEMC_SC_CIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_OTH_SEL, MEMC_SC_MUPDTT_SEL, MEMC_LO_SEL))
+
+#define MEMC_CS_LIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_LOC_SEL, MEMC_CS_MINVLT_SEL, MEMC_LO_SEL))
+#define MEMC_CS_RIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_REM_SEL, MEMC_CS_MINVLT_SEL, MEMC_LO_SEL))
+#define MEMC_CS_CIDX      (MEMC_REG_IDX(MEMC_DIRCT_SEL, MEMC_OTH_SEL, MEMC_CS_MINVLT_SEL, MEMC_LO_SEL))
+
+#define MEMC_RD_LOCAL      MEMC_REG(MEMC_PRF_FUNC, MEMC_RD_LIDX)
+#define MEMC_RD_REMOTE     MEMC_REG(MEMC_PRF_FUNC, MEMC_RD_RIDX)
+#define MEMC_RD_COST       MEMC_REG(MEMC_PRF_FUNC, MEMC_RD_CIDX)
+
+#define MEMC_WR_LOCAL      MEMC_REG(MEMC_PRF_FUNC, MEMC_WR_LIDX)
+#define MEMC_WR_REMOTE     MEMC_REG(MEMC_PRF_FUNC, MEMC_WR_RIDX)
+#define MEMC_WR_COST       MEMC_REG(MEMC_PRF_FUNC, MEMC_WR_CIDX)
+
+#define MEMC_LL_LOCAL      MEMC_REG(MEMC_PRF_FUNC, MEMC_LL_LIDX)
+#define MEMC_LL_REMOTE     MEMC_REG(MEMC_PRF_FUNC, MEMC_LL_RIDX)
+#define MEMC_LL_COST       MEMC_REG(MEMC_PRF_FUNC, MEMC_LL_CIDX)
+
+#define MEMC_SC_LOCAL      MEMC_REG(MEMC_PRF_FUNC, MEMC_SC_LIDX)
+#define MEMC_SC_REMOTE     MEMC_REG(MEMC_PRF_FUNC, MEMC_SC_RIDX)
+#define MEMC_SC_COST       MEMC_REG(MEMC_PRF_FUNC, MEMC_SC_CIDX)
+
+#define MEMC_CS_LOCAL      MEMC_REG(MEMC_PRF_FUNC, MEMC_CS_LIDX)
+#define MEMC_CS_REMOTE     MEMC_REG(MEMC_PRF_FUNC, MEMC_CS_RIDX)
+#define MEMC_CS_COST       MEMC_REG(MEMC_PRF_FUNC, MEMC_CS_CIDX)
+
+/* ------------------------------------------- */
+/* PERFORMANCE REGISTERS FOR COHERENCE TRAFFIC */
+/* ------------------------------------------- */
+
+#define MEMC_MUPDT_LIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_LOC_SEL, MEMC_RD_MUPDT_SEL, MEMC_LO_SEL))
+#define MEMC_MUPDT_RIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_REM_SEL, MEMC_RD_MUPDT_SEL, MEMC_LO_SEL))
+#define MEMC_MUPDT_CIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_OTH_SEL, MEMC_RD_MUPDT_SEL, MEMC_LO_SEL))
+
+#define MEMC_MINVL_LIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_LOC_SEL, MEMC_WR_MINVL_SEL, MEMC_LO_SEL))
+#define MEMC_MINVL_RIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_REM_SEL, MEMC_WR_MINVL_SEL, MEMC_LO_SEL))
+#define MEMC_MINVL_CIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_OTH_SEL, MEMC_WR_MINVL_SEL, MEMC_LO_SEL))
+
+#define MEMC_CLNUP_LIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_LOC_SEL, MEMC_LL_CLNUP_SEL, MEMC_LO_SEL))
+#define MEMC_CLNUP_RIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_REM_SEL, MEMC_LL_CLNUP_SEL, MEMC_LO_SEL))
+#define MEMC_CLNUP_CIDX      (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_OTH_SEL, MEMC_LL_CLNUP_SEL, MEMC_LO_SEL))
+
+#define MEMC_MUPDTT_TIDX     (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_OTH_SEL, MEMC_SC_MUPDTT_SEL, MEMC_LO_SEL))
+#define MEMC_MINVLT_TIDX     (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_OTH_SEL, MEMC_CS_MINVLT_SEL, MEMC_LO_SEL))
+#define MEMC_BINVLT_TIDX     (MEMC_REG_IDX(MEMC_COHER_SEL, MEMC_OTH_SEL, MEMC_XX_BINVLT_SEL, MEMC_LO_SEL))
+
+#define MEMC_MUPDT_LOCAL     MEMC_REG(MEMC_PRF_FUNC, MEMC_MUPDT_LIDX)
+#define MEMC_MUPDT_REMOTE    MEMC_REG(MEMC_PRF_FUNC, MEMC_MUPDT_RIDX)
+#define MEMC_MUPDT_COST      MEMC_REG(MEMC_PRF_FUNC, MEMC_MUPDT_CIDX)
+
+#define MEMC_MINVL_LOCAL     MEMC_REG(MEMC_PRF_FUNC, MEMC_MINVL_LIDX)
+#define MEMC_MINVL_REMOTE    MEMC_REG(MEMC_PRF_FUNC, MEMC_MINVL_RIDX)
+#define MEMC_MINVL_COST      MEMC_REG(MEMC_PRF_FUNC, MEMC_MINVL_CIDX)
+
+#define MEMC_CLNUP_LOCAL     MEMC_REG(MEMC_PRF_FUNC, MEMC_CLNUP_LIDX)
+#define MEMC_CLNUP_REMOTE    MEMC_REG(MEMC_PRF_FUNC, MEMC_CLNUP_RIDX)
+#define MEMC_CLNUP_COST      MEMC_REG(MEMC_PRF_FUNC, MEMC_CLNUP_CIDX)
+
+#define MEMC_MUPDT_TOTAL     MEMC_REG(MEMC_PRF_FUNC, MEMC_MUPDTT_TIDX)
+#define MEMC_MINVL_TOTAL     MEMC_REG(MEMC_PRF_FUNC, MEMC_MINVLT_TIDX)
+#define MEMC_BINVL_TOTAL     MEMC_REG(MEMC_PRF_FUNC, MEMC_BINVLT_TIDX)
+
+#define MEMC_REG_NR 27
+
+static const uint16_t reg_tbl[MEMC_REG_NR] = {
+		MEMC_RD_LOCAL,
+		MEMC_RD_REMOTE,
+		MEMC_RD_COST,
+		MEMC_WR_LOCAL,
+		MEMC_WR_REMOTE,
+		MEMC_WR_COST,
+		MEMC_LL_LOCAL,
+		MEMC_LL_REMOTE,
+		MEMC_LL_COST,
+		MEMC_SC_LOCAL,
+		MEMC_SC_REMOTE,
+		MEMC_SC_COST,
+		MEMC_CS_LOCAL,
+		MEMC_CS_REMOTE,
+		MEMC_CS_COST,
+		MEMC_MUPDT_LOCAL,
+		MEMC_MUPDT_REMOTE,
+		MEMC_MUPDT_COST,
+		MEMC_MINVL_LOCAL,
+		MEMC_MINVL_REMOTE,
+		MEMC_MINVL_COST,
+		MEMC_CLNUP_LOCAL,
+		MEMC_CLNUP_REMOTE,
+		MEMC_CLNUP_COST,
+		MEMC_MUPDT_TOTAL,
+		MEMC_MINVL_TOTAL,
+		MEMC_BINVL_TOTAL};
+
+static sint_t memc_read(struct device_s *memc, dev_request_t *rq)
+{	
+	register size_t count;
+	register uint_t i;
+	uint_t *dst;
+		      
+	assert(rq->file != NULL);
+  
+	count = rq->count >> 2;	/* 32 bits registers */
+	dst   = rq->dst;
+
+	count = (count > MEMC_REG_NR) ? MEMC_REG_NR : count;
+
+	for(i = 0; i < count; i++)
+	{
+		memcpy((void*)&dst[i], (void *)((uint_t)memc->base + reg_tbl[i]), 4);
+	}
+	return (count << 2);
+}
+
+static sint_t memc_write(struct device_s *memc, dev_request_t *rq)
+{
+	return -ENOTSUPPORTED;
+}
+
+static error_t memc_lseek(struct device_s *memc, dev_request_t *rq)
+{
+	return ENOTSUPPORTED;
+}
+
+static sint_t memc_get_params(struct device_s *memc, dev_params_t *params)
+{
+	params->size = MEMC_REG_NR * 4; /* 32 bits registers */
+	return 0;
+}
+
+static sint_t memc_open(struct device_s *memc, dev_request_t *rq)
+{
+	return 0;
+}
+
+static VM_REGION_PAGE_FAULT(memc_pagefault)
+{
+	return EFAULT;
+}
+
+static struct vm_region_op_s memc_vm_region_op = 
+{
+	.page_in     = NULL,
+	.page_out    = NULL,
+	.page_lookup = NULL,
+	.page_fault  = memc_pagefault
+};
+
+static error_t memc_mmap(struct device_s *memc, dev_request_t *rq)
+{
+	struct vfs_file_s *file;
+	struct vm_region_s *region;
+	struct pmm_s *pmm;
+	uint_t size;
+	pmm_page_info_t info;
+	vma_t current_vma;
+	error_t err;
+
+	file   = rq->file;
+	region = rq->region;
+	pmm    = &region->vmm->pmm;
+	size   = (uint_t) memc->data;
+  
+	if(size < (region->vm_limit - region->vm_start))
+	{
+		printk(WARNING, "WARNING: %s: asked size (%d) exceed real one (%d)\n", 
+		       __FUNCTION__, region->vm_limit - region->vm_start, size);
+		return ERANGE;
+	}
+
+	printk(INFO, "INFO: %s: started, file inode %p, region <0x%x - 0x%x>\n",
+	       __FUNCTION__, 
+	       file->f_inode, 
+	       region->vm_start, 
+	       region->vm_limit);
+
+	if((err = pmm_get_page(pmm, (vma_t)memc->base, &info)))
+		return err;
+
+	region->vm_flags |= VM_REG_DEV;
+	current_vma       = region->vm_start;
+	info.attr         = region->vm_pgprot & ~(PMM_CACHED);
+	info.cluster      = NULL;
+	size              = region->vm_limit - region->vm_start; 
+	size              = ARROUND_UP(size, PMM_PAGE_SIZE);
+
+	while(size)
+	{
+		if((err = pmm_set_page(pmm, current_vma, &info)))
+			return err;
+
+		info.ppn ++;
+		current_vma += PMM_PAGE_SIZE;
+		size -= PMM_PAGE_SIZE;
+	}
+  
+	region->vm_file = *file;
+	//region->vm_mapper = NULL;
+
+	region->vm_op = &memc_vm_region_op;
+	return 0;
+}
+
+static error_t memc_munmap(struct device_s *memc, dev_request_t *rq)
+{
+	struct vfs_file_s *file;
+	struct vm_region_s *region;
+	struct pmm_s *pmm;
+	uint_t size;
+	pmm_page_info_t info;
+	vma_t current_vma;
+	error_t err;
+
+	file   = rq->file;
+	region = rq->region;
+	pmm    = &region->vmm->pmm;
+	size   = (uint_t) memc->data;
+
+	if(size < (region->vm_limit - region->vm_start))
+	{
+		printk(ERROR, "ERROR: %s: asked size (%d) exceed real one (%d)\n", 
+		       __FUNCTION__, region->vm_limit - region->vm_start, size);
+		return ERANGE;
+	}
+
+	current_vma = region->vm_start;
+	info.attr   = 0;
+	info.ppn    = 0;
+	size        = region->vm_limit - region->vm_start;
+
+	while(size)
+	{    
+		if((err = pmm_set_page(pmm, current_vma, &info)))
+			return err;
+
+		current_vma += PMM_PAGE_SIZE;
+		size -= PMM_PAGE_SIZE;
+	}
+  
+	return 0;
+}
+
+static uint_t memc_count = 0;
+
+error_t soclib_memc_init(struct device_s *memc)
+{  
+	memc->type = DEV_CHR;
+
+	memc->op.dev.open       = &memc_open;
+	memc->op.dev.read       = &memc_read;
+	memc->op.dev.write      = &memc_write;
+	memc->op.dev.close      = NULL;
+	memc->op.dev.lseek      = &memc_lseek;
+	memc->op.dev.mmap       = &memc_mmap;
+	memc->op.dev.munmap     = &memc_munmap;
+	memc->op.dev.set_params = NULL;
+	memc->op.dev.get_params = &memc_get_params;
+	memc->op.drvid          = SOCLIB_MEMC_ID;
+
+	memc->data = (void*)memc->size;
+
+	sprintk(memc->name, 
+#if CONFIG_ROOTFS_IS_VFAT
+		"MEMC%d"
+#else
+		"memc%d"
+#endif
+		, memc_count++);
+
+	metafs_init(&memc->node, memc->name);
+	return 0;
+}
+
+
+driver_t soclib_memc_driver = { .init = &soclib_memc_init };
Index: trunk/kernel/drivers/soclib/soclib_memc.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_memc.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_memc.h	(revision 1)
@@ -0,0 +1,28 @@
+/*
+ * soclib_memc.h - soclib/tsar L2 Confugration Controller
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012,2013 Ghassan Almaless
+ * Copyright (c) 2011,2012,2013 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_MEMC_H_
+#define _SOCLIB_MEMC_H_
+
+extern driver_t soclib_memc_driver;
+
+#endif
Index: trunk/kernel/drivers/soclib/soclib_mmc.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_mmc.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_mmc.c	(revision 1)
@@ -0,0 +1,146 @@
+/*
+ * soclib_mmc.c - soclib simple block device driver implementation.
+ *
+ * Author     Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH..
+ *
+ * ALMOS-MKH. is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH. is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+
+#include <hal_types.h>
+#include <device.h>
+#include <dev_mmc.h>
+#include <soclib_mmc.h>
+#include <spinlock.h>
+#include <thread.h>
+#include <printk.h>
+
+
+/////////////////////////////////////
+void soclib_mmc_init( xptr_t dev_xp )
+{
+    // get local pointer on MMC device descriptor
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get extended pointer on MMC peripheral from MMC device
+    xptr_t  mmc_xp = dev_ptr->base;
+
+    // get local pointer on MMC segment base
+    uint32_t * base = (uint32_t *)GET_PTR( mmc_xp );
+
+    // enable MMC IRQ
+    *(base + (SOCLIB_MMC_ERROR_FUNC << 7) + SOCLIB_MMC_ERROR_IRQ_ENABLE) = 1;
+} 
+
+
+//////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_mmc_command( xptr_t th_xp )
+{
+    xptr_t     dev_xp;       // extended pointer on MMC device
+    uint32_t   type;         // MMC command : type
+    uint64_t   buf_paddr;    // MMC command : buffer physical address
+    uint32_t   buf_size;     // MMC command : buffer size
+    uint32_t   reg_index;    // MMC command : register index in MMC peripheral
+    uint32_t * reg_ptr;      // MMC command : pointer on dst/src buffer in client cluster 
+
+    // get client thread cluster and local pointer
+    cxy_t      th_cxy = GET_CXY( th_xp );
+    thread_t * th_ptr = (thread_t *)GET_PTR( th_xp );
+
+    // get command type and extended pointer on MMC device
+    type   =         hal_remote_lw ( XPTR( th_cxy , &th_ptr->dev.mmc.type   ) );
+    dev_xp = (xptr_t)hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.mmc.dev_xp ) );
+
+    // get MMC device cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get extended pointer on SOCLIB-MMC peripheral
+    xptr_t     mmc_xp = hal_remote_lw( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get SOCLIB_MMC peripheral cluster and local pointer
+    cxy_t      mmc_cxy = GET_CXY( mmc_xp );
+    uint32_t * mmc_ptr = (uint32_t *)GET_PTR( mmc_xp );
+
+    if( (type == MMC_CC_INVAL) || (type == MMC_CC_SYNC) )
+    {
+        // get buffer paddr
+        buf_paddr = hal_remote_lwd( XPTR( th_cxy , &th_ptr->dev.mmc.buf_paddr ) );
+
+        // split buffer paddr in two 32 bits words
+        uint32_t   buf_lo = (uint32_t)( buf_paddr );
+        uint32_t   buf_hi = (uint32_t)( buf_paddr>>32 );
+
+        // get buffer size
+        buf_size   = hal_remote_lw( XPTR( th_cxy , &th_ptr->dev.mmc.buf_size ) );
+
+        // get command type
+        uint32_t cc_cmd = MMC_CC_INVAL ? SOCLIB_MMC_CC_INVAL : SOCLIB_MMC_CC_SYNC; 
+
+        // set SOCLIB_MMC registers to start INVAL/SYNC operation
+        hal_remote_sw( XPTR( mmc_cxy , mmc_ptr + SOCLIB_MMC_ADDR_LO    ) , buf_lo );
+        hal_remote_sw( XPTR( mmc_cxy , mmc_ptr + SOCLIB_MMC_ADDR_HI    ) , buf_hi );
+        hal_remote_sw( XPTR( mmc_cxy , mmc_ptr + SOCLIB_MMC_BUF_LENGTH ) , buf_size ); 
+        hal_remote_sw( XPTR( mmc_cxy , mmc_ptr + SOCLIB_MMC_CMD_TYPE   ) , cc_cmd ); 
+    }
+    else  // (type == MMC_GET_ERROR) or (type == MMC_GET_ERROR) pr (type == MMC_GET_INSTRU )
+    {
+        // get src/dst buffer local pointer and register index
+        reg_ptr   = (uint32_t *)hal_remote_lpt( XPTR( th_cxy , &th_ptr->dev.mmc.reg_ptr ) );
+        reg_index = hal_remote_lw( XPTR( th_cxy , &th_ptr->dev.mmc.reg_index ) );
+
+        // move register to/from local buffer 
+        if( (type == MMC_GET_ERROR) || (type == MMC_GET_INSTRU) )
+        {
+            *reg_ptr =  hal_remote_lw( XPTR( mmc_cxy , mmc_ptr + reg_index ) );
+        }
+        else  // type == MMC_SET_ERROR
+        {
+            hal_remote_sw( XPTR( mmc_cxy , mmc_ptr + reg_index ) , *reg_ptr );
+        }
+    }
+} // end soclib_mmc_cmd()
+
+
+////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_mmc_isr( device_t * dev )
+{
+    // get extended pointer on MMC peripheral from MMC device
+    xptr_t  mmc_xp = dev->base;
+
+    // get local pointer on MMC segment base
+    uint32_t * base = (uint32_t *)GET_PTR( mmc_xp );
+
+    // get faulty ADDRESS and SRCID from MMC registers
+    uint32_t paddr_lo = *(base + (SOCLIB_MMC_ERROR_FUNC << 7) + SOCLIB_MMC_ERROR_ADDR_LO);
+    uint32_t paddr_hi = *(base + (SOCLIB_MMC_ERROR_FUNC << 7) + SOCLIB_MMC_ERROR_ADDR_HI);
+    uint32_t srcid    = *(base + (SOCLIB_MMC_ERROR_FUNC << 7) + SOCLIB_MMC_ERROR_SRCID);
+
+    paddr_t paddr = (((paddr_t)paddr_hi)<<32) + ((paddr_t)paddr_lo);
+    
+    // reset MMC IRQ
+    *(base + (SOCLIB_MMC_ERROR_FUNC << 7) + SOCLIB_MMC_ERROR_IRQ_RESET) = 0;
+    
+    // print an error message on kernel terminal TODO : should be improved
+    printk("\n[ERROR] reported from MMC in cluster %x : faulty address = %l / srcid = %x\n",
+           paddr , srcid );
+
+} // end soclib_mmc_isr()
+
+
+
